package edu.uw.cameratest;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import android.app.Activity;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.hardware.Camera;
import android.hardware.Camera.Parameters;
import android.os.Bundle;
import android.os.Environment;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.widget.ImageView;
import sparta.checkers.quals.*;

import sparta.checkers.quals.FlowSources.FlowSource;
import sparta.checkers.quals.FlowSinks.FlowSink;

public class CameraTestActivity extends Activity implements SurfaceHolder.Callback
{
    //a variable to store a reference to the Image View at the main.xml file
    private ImageView iv_image;
    //a variable to store a reference to the Surface View at the main.xml file
    private SurfaceView sv;

    //a bitmap to display the captured image
    private @FlowSources(FlowSource.CAMERA) Bitmap bmp;

    //Camera variables
    //a surface holder
    private SurfaceHolder sHolder;
    //a variable to control the camera
    private Camera mCamera;
    //the camera parameters
    private Parameters parameters;

    /** Called when the activity is first created. */
    @RequiredPermissions(android.Manifest.permission.INTERNET)
    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);

        //get the Image View at the main.xml file
        iv_image = (ImageView) findViewById(R.id.imageView1);

        //get the Surface View at the main.xml file
        sv = (SurfaceView) findViewById(R.id.surfaceView1);

        //Get a surface
        sHolder = sv.getHolder();

        //add the callback interface methods defined below as the Surface View callbacks
        sHolder.addCallback(this);

        //tells Android that this surface will have its data constantly replaced
        sHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    @Override
    public void surfaceChanged(SurfaceHolder arg0, int arg1, int arg2, int arg3)
    {
         //get camera parameters
         parameters = mCamera.getParameters();

         //set camera parameters
         mCamera.setParameters(parameters);
         mCamera.startPreview();
         final Context ctx = this;
         //sets what code should be executed after the picture is taken
         Camera.PictureCallback mCall = new Camera.PictureCallback()
         {
             @Override
             public void onPictureTaken(@FlowSources(sparta.checkers.quals.FlowSources.FlowSource.CAMERA) byte[] data, Camera camera)
             {
            	 Log.w("test","hi");
                 //decode the data obtained by the camera into a Bitmap
                 bmp = BitmapFactory.decodeByteArray(data, 0, data.length);
                 //set the iv_image
                 iv_image.setImageBitmap(bmp);
                 @SuppressWarnings("flow")
                 @FlowSinks(FlowSink.FILESYSTEM) @FlowSources(FlowSource.CAMERA) ByteArrayOutputStream bytes = new ByteArrayOutputStream();
                 bmp.compress(Bitmap.CompressFormat.JPEG, 40, bytes);

                 //you can create a new file name "test.jpg" 
                 @SuppressWarnings("flow")
                 @FlowSinks(FlowSink.FILESYSTEM) @FlowSources String dirName = "log";
                 @SuppressWarnings("flow")
                 @FlowSinks(FlowSink.FILESYSTEM) @FlowSources String jpgName = "test.jpg";
                 @SuppressWarnings("flow")
                 @FlowSinks(FlowSink.FILESYSTEM) @FlowSources File f = new File(ctx.getDir(dirName, Context.MODE_PRIVATE)
                                         + File.separator + jpgName);
                 try {
					f.createNewFile();
					@SuppressWarnings("flow")
					@FlowSinks(FlowSink.FILESYSTEM) FileOutputStream fo = new FileOutputStream(f);
					@SuppressWarnings("flow") // OK to write camera data
					@FlowSinks({FlowSink.FILESYSTEM}) @FlowSources({FlowSource.ANY}) byte /*@FlowSinks*/ /*@FlowSources*/ [] ba = bytes.toByteArray();
	                 fo.write(ba);
	                 fo.close();
	                 bytes.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
                 //write the bytes in file
                 
             }
         };

         mCamera.takePicture(null, null, mCall);
    }

    @RequiredPermissions(android.Manifest.permission.CAMERA)
    @Override
    public void surfaceCreated(SurfaceHolder holder)
    {
        // The Surface has been created, acquire the camera and tell it where
        // to draw the preview.
        mCamera = Camera.open();
        try {
           mCamera.setPreviewDisplay(holder);

        } catch (IOException exception) {
            mCamera.release();
            mCamera = null;
        }
    }

    @Override
    public void surfaceDestroyed(SurfaceHolder holder)
    {
        //stop the preview
        mCamera.stopPreview();
        //release the camera
        mCamera.release();
        //unbind the camera from this object
        mCamera = null;
    }
}
